/* 1) importation */
libname a 'C:\cours\sas';
DATA a.cardata;
INFILE 'C:\cours\sas\TP2\cardata.txt' ;
INPUT (q1-q8) (1.) @@;
label q1='Origine' q2='Taille' q3='Type' q4='Appartenance' q5='Nb revenu' q6='Etat civil' q7='Nombre d''enfants' q8='Sexe';
RUN;
/* 2) recodage */
   /* dfinition des formats pour le recodage */
proc format;
   value ori 1='Americaine' 2='Japonaise' 3='Europeenne';
   value tai 1='petite' 2='moyenne' 3='grande';
   value typ 1='familiale' 2='sport' 3='utilitaire';
   value sta 1='proprietaire' 2='louee';
   value etc 1='celibataire' 2= 'marie(e)';
   value sex 1='M' 2='F';
QUIT;
   
DATA a.cardata;
SET a.cardata;
format q1 ori. q2 tai. q3 typ. q4 sta. q6 etc. q8 sex. ;
RUN;

/* 3) passage table sas --> matrices iml */
proc iml;
use a.cardata;
read all var {'q1' 'q2' 'q3' 'q4' 'q5' 'q6' 'q7' 'q8'}into x;
print x;
close;

show names;
print/"Matrice des Donnees Cardata";
idvar={'Origine' 'Taille' 'Type' 'Appartenance' 'Nb revenu' 'Etat civil' 'Nombre d enfants' 'Sexe'};
ident=t('1':char(nrow(x),3));
print x[rowname=ident colname=idvar];

/* nombre total de donnees manquantes et les numeros des lignes ou elles sont localisees */
reset storage=a.stage;
show storage;
load module=manquant2;

run manquant2(x);

/* le nombre de rponses diffrentes pour chaque question. par ex. Combien y a t il les femmes? */

reset storage=a.stage;
show storage;
load module=dnombr;

do i=1 to 8;
run dnombr(nl,ldif,eff,x[,i]);
/* print nl, ldif, eff; */
z=ldif//eff; print z;
end;

print(x[<>]);

/* completer les donnees manquantes */
reset storage=a.stage;
show storage;
load module=complet;

code=j(nrow(x),1,1);
w={100 400 400 200 400 300 400 400};
ce=complet(x,code,w);

/*code={1 4 4 2 4 3 4 4};
c1=j(nrow(x),1,100);
c2=j(nrow(x),1,200);
c3=j(nrow(x),1,300);
c4=j(nrow(x),1,400);
w=c1||c2||c3||c4;
ce=complet(t(x),t(code),t(w));
ce=t(ce);*/

print/"Matrice completee";
idvar={'Origine' 'Taille' 'Type' 'Appartenance' 'Nb revenu' 'Etat civil' 'Nombre d enfants' 'Sexe'};
ident=t('1':char(nrow(x),3));
print ce[rowname=ident colname=idvar];

/* 4) passage matrice iml --> table sas */
idvar='q1':'q8';
create a.cardata2 from ce[rowname=ident colname=idvar];
append from ce[rowname=ident];
close;
quit;

/* 5) recodage */
   /* dfinition des formats pour le recodage */
proc format;
   value ori 1='Americaine' 2='Japonaise' 3='Europeenne' 100='Autre';
   value tai 1='petite' 2='moyenne' 3='grande' 400='NR';
   value typ 1='familiale' 2='sport' 3='utilitaire' 400='NR';
   value sta 1='proprietaire' 2='louee' 200='heberge';
   value rev 400='NR';
   value etc 1='celibataire' 2= 'marie(e)' 300='Pacs';
   value enf 400='NR';
   value sex 1='M' 2='F' 400='NR';
QUIT;
   
DATA a.cardata2;
SET a.cardata2;
format q1 ori. q2 tai. q3 typ. q4 sta. q5 rev. q6 etc. q7 enf. q8 sex. ;
RUN;

/* exo */

proc iml;

M={1 2,3 4};
x=M[##,];
print x; 
y=M[##,][>:<];
print y;

z=sqrt(M[##,][<>]);
print z;

x=diag(M);
print x;

/* 
DATA a.cardata;
INFILE 'C:\cours\sas\TP2\cardata.txt' ;
ATTRIB q1-q4
format=$1.;

ATTRIB q5 
format=1.;

ATTRIB q6
format=$1.;

ATTRIB q7
format=1.;

ATTRIB q8
format=$1.;
label q1='Origine' q2='Taille' q3='Type' q4='Appartenance' q5='Nb revenu' q6='Etat civil' q7='Nombre d enfants' q8='Sexe';
INPUT q1-q8 @@;
RUN;
*/


xy={1 2, 3 3, 5 4, 6 2};
call pgraf(xy,"*","X","Y","Plot of X vs Y");

